package org.computer.aman.metrics.util;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;

import org.computer.aman.io.sourcecode.NotSupportedSourceFileExeption;
import org.computer.aman.io.sourcecode.SourceFile;

/**
 * ɤƤɽɥޥå
 * <p>
 * ɥޥåפϡɤƤʸñ̤ɽޥåפǤ롥<br>
 * 㤨С 0餫Υɤ 1, Ȥ 2 Ȥơ<br>
 * <pre>   public int x; // ɸ</pre>
 * 
 * <pre>0001111110111011022022</pre>
 * ɽ롥
 * <p>
 * ܥ饹Υ󥹥󥹤Ǥϡ
 * ԤȤΥɥޥåץ֥ȡCodeLineMap 󥹥󥹡ˤꥹȤȤݻ롥
 * <p>
 * Ūˤɤäͤޥåפ˻ȤΤϡCodeLineMap Υ֥饹ʸ줴Ȥò줿饹ˤ˰¸롥
 * 
 * @author Hirohisa AMAN &lt;aman@computer.org&gt;
 * @version $Id: CodeMap.java,v 1.1 2009/03/26 04:48:33 aman Exp $
 *
 */
public abstract class CodeMap
{
    /**
     * եγĥҡʥץߥ󥰸ˤ˱Ŭڤ CodeMap ֥Ȥ
     * 
     * @param aSourceFile ե
     * @return ꤵ줿եεҸб CodeMap ֥
     * @throws NotSupportedSourceFileExeption ꤵ줿ե뤬бθǽ񤫤Ƥ
     * @throws IOException Ϥǲ餫㳰ȯ
     */
    public static CodeMap create(final SourceFile aSourceFile) 
    throws NotSupportedSourceFileExeption, IOException
    {
        final String EXT = aSourceFile.getExtension();
        if ( EXT.equalsIgnoreCase("java") ){
            return new CodeMapForJava(aSourceFile);
        }
        if ( EXT.equalsIgnoreCase("c") || EXT.equalsIgnoreCase("h") || EXT.equalsIgnoreCase("cpp") ||
                EXT.equalsIgnoreCase("cc") || EXT.equalsIgnoreCase("cxx") || EXT.equalsIgnoreCase("m") ||
                EXT.equalsIgnoreCase("i") || EXT.equalsIgnoreCase("ii") || EXT.equalsIgnoreCase("h") ){
            return new CodeMapForCandCPP(aSourceFile);
        }
        
        return null;
    }
    
    /**
     * ԤȤΥɥޥåפ򥤥ƥ졼Ȥ֤
     * 
     * @return ԤȤΥɥޥåפФ륤ƥ졼
     */
    public Iterator<CodeLineMap> iterator()
    {
        return lines.iterator();
    }
    
    /**
     * ɥޥåפƤʸΤ֤
     * 
     * @return ʸ󲽤줿ɥޥå
     */
    public String toString()
    {
        StringBuffer buf = new StringBuffer();
        int lineNumber = 1;
        for (Iterator<CodeLineMap> iterator = lines.iterator(); iterator.hasNext();) {
            CodeLineMap element = iterator.next();
            buf.append(lineNumber++);
            buf.append(element.toString());
            buf.append("\n");
        }
        
        return new String(buf);
    }
    
    /**
     * CodeLineMap 󥹥󥹤򥳡ɥޥåפɲä
     * 
     * @param aLineMap ɥޥåפɲä CodeLineMap 󥹥
     */
    protected void add(final CodeLineMap aLineMap)
    {
        if ( lines == null ){
            lines = new ArrayList<CodeLineMap>();
        }
        lines.add(aLineMap);
    }
    
    /** 
     * ɥޥåפ:
     * ñ̤ǤΥɥޥåפ CodeLineMap ֥Ȥ
     * դꥹȤȤݻ
     */
    private ArrayList<CodeLineMap> lines;
}
