package org.computer.aman.metrics.util;

/**
 * C/C++ ɰʬΥɥޥåפ륯饹Ǥ롥
 * <p>
 * ɥޥåפȤϡɤƤǤʸ<br>
 * (1)ɤΰ(2)ࡤ(3)ʸΰ<br>
 * Τ줫ʬष餫줿ͤǤɽΤǤ롥
 * <p>
 * (1)  CODE(2)  BLANK Ǥ줾ɽ롥<br>
 * (3) ˤĤƤϡ// ޤǤΥȤ EOL_COMMENT ǡ
 * C ν褫ηΥȤ TRADITIONAL_COMMENT Ǥ줾ɽ롥
 * 
 * @author Hirohisa AMAN &lt;aman@computer.org&gt;
 * @version $Id$
 */
public class CodeLineMapForCandCPP extends CodeLineMap
{
    /** ޥå׾ǡʸ // ΥȤǤ뤳Ȥɽ */
    public static final String EOL_COMMENT = "2";
    
    /** ޥå׾ǡʸ C ΥȤǤ뤳Ȥɽ */
    public static final String TRADITIONAL_COMMENT = "3";
    
    /**
     * ʬΥɥޥåפꤹ롥 
     * @param aMap ʬΥɥޥå
     */
    public CodeLineMapForCandCPP(final String aMap)
    {
        super(aMap);
        
        eolCommentCount = 0;
        traditionalCommentCount = 0;
        for (int i = 0; i < aMap.length(); i++ ){
            String ithChar = Character.toString(aMap.charAt(i));
            if ( EOL_COMMENT.equals(ithChar) ){
                eolCommentCount++;
            }
            else if ( TRADITIONAL_COMMENT.equals(ithChar) ){
                traditionalCommentCount++;
            }
        }
    }

    /**
     * EOL ΥȤʸ֤
     *
     * @return EOL ΥȤʸ
     */
    public int getEolCommentCount()
    {
        return eolCommentCount;
    }

    /**
     * C ΥȤʸ֤
     *
     * @return C ΥȤʸ
     */
    public int getTraditionalCommentCount()
    {
        return traditionalCommentCount;
    }

    /**
     * ʬΥɥޥåפơΥդˤʸˤ֤
     * <br>
     * Ƥ (b?,c?,#?:t?,e?,j?) ....... 
     * ȤˤʤäƤꡤ
     * 줾֤˶ʸʸʸTraditional ʸEOL ʸJavadoc ʸ
     * ? ꡤθ˥ɥޥåפƤ³
     * <br>
     * ʤʸ = Traditional ʸ + EOL ʸ + Javadoc ʸǤ롥
     * @return ʬΥɥޥåפ
     */
    public String toString()
    {
        StringBuffer buf = new StringBuffer();        
        buf.append("(b" + getBlankCount() + ",c" + getCodeCount() + ",#" + getCommentCount() + ":");
        buf.append("t" + getTraditionalCommentCount() + ",");
        buf.append("e" + getEolCommentCount() + ")");
        buf.append(" ");
        buf.append(getMap());
        
        return new String(buf);
    }

    /** EOL ΥȤʸ */
    private int eolCommentCount;

    /** C ΥȤʸ */
    private int traditionalCommentCount;

}
